(function(){

let add_symbol = (str, symbol, len, side)=>{
    let cur_len, i;
    if (!str)
        str = '';
    str = str.toString();
    if (!side)
        side = 'left';
    if (symbol === undefined)
        symbol = '0';
    symbol.toString();
    cur_len = str.length;
    if (side === 'left')
    {
        for (i = 0; i < (len - cur_len); ++i)
            str = symbol+str;
    }
    else
    {
        for (i = 0; i < (len - cur_len); ++i)
            str += symbol;
    }
    return str;
};

let get_curdate = ()=>{
    let date = new Date(),
        d = date.getDate(),
        m = date.getMonth() + 1,
        y = date.getFullYear(),
        H = date.getHours(),
        M = date.getMinutes(),
        S = date.getSeconds();
    d = add_symbol(d, '0', 2, 'left');
    m = add_symbol(m, '0', 2, 'left');
    H = add_symbol(H, '0', 2, 'left');
    M = add_symbol(M, '0', 2, 'left');
    S = add_symbol(S, '0', 2, 'left');
    return `${y}-${m}-${d} ${H}-${M}-${S}.png`;
};

let get_filename = ()=>'Screenshot '+get_curdate();

let take_screenshot = ()=>{
    chrome.tabs.captureVisibleTab(null, {format: 'png'}, img=>{
        chrome.downloads.download({url: img, filename: get_filename(),
             saveAs: true});
    });
};

let run = ()=>{
    chrome.browserAction.onClicked.addListener(take_screenshot);
};

run();

}());
